import {
  Style,
  Button,
  Scroll,
  Popup,
  TimePicker,
  CascadePicker,
  Dialog,
  Tip,
  Toast,
  ActionSheet,
  CheckboxGroup,
  Slide,
  IndexList,
  BScroll,
  createAPI
} from './module'

function install(Vue) {
  if (install.installed) {
    return
  }
  install.installed = true
  const components = [
    Style,
    Button,
    TimePicker,
    CascadePicker,
    Dialog,
    Tip,
    Toast,
    CheckboxGroup,
    Slide,
    IndexList,
    ActionSheet,
    Scroll,
    Popup
  ]
  components.forEach((Component) => {
    Component.install(Vue)
  })
}

const cube = {
  /* eslint-disable no-undef */
  version: '1.2.4',
  install,
  BScroll,
  createAPI
}

if (typeof window !== 'undefined' && window.Vue) {
  window.Vue.use(install)
}

export default cube
